{-# LANGUAGE FunctionalDependencies #-}
module Sources where

import Data.ByteString (ByteString)

data Source a where
  Data :: a -> Source a

class SourceState a where
  stateOfSource :: a -> IO ByteString

instance SourceState FilePath where
  stateOfSource = undefined

class (SourceState a, Show f) => IsFIO f a b | f -> a b where
  runFIO :: f -> a -> IO b
